
ArrayList<ForcePoint>  forcePointList = new ArrayList<ForcePoint>();
int                     borderDist = 30;
int                     gridX = 60;
int                     gridY = 60;

void setup()
{
  size(600,600);
  
  // setup the grid
  float stepX = (float)(width - borderDist * 2) / (gridX - 1);
  float stepY = (float)(height - borderDist * 2) / (gridY - 1);
  
  for(int x=0;x < gridX;x++)
  {
    for(int y=0;y < gridY;y++)
    {
      forcePointList.add(new ForcePointTrail((int)(stepX * x + borderDist),(int)(stepY * y + borderDist),200,0.7f));      
    } 
  }
  
}

void draw()
{
  background(0);
  
  updateForceField();
  
  ForcePoint forcePoint; 
  for(int i=0;i < forcePointList.size();i++)
  {
    forcePoint = forcePointList.get(i);  
    
    forcePoint.update();
    forcePoint.draw();
  }
}

void updateForceField()
{  
  ForcePoint forcePoint; 
  
  for(int i=0;i < forcePointList.size();i++)
  {
    forcePoint = forcePointList.get(i);  
    
    if(mousePressed &&  mouseButton == LEFT)
      forcePoint.setInput(mouseX,mouseY,0);
    else if(mousePressed &&  mouseButton == RIGHT)
      forcePoint.setInput(mouseX,mouseY,1);
  }
}

void keyPressed() {
  if (key == 's') {
    save(String.valueOf(year()) + String.valueOf(nf(month(),2)) + String.valueOf(nf(day(),2)) + "-" + String.valueOf(nf(hour(),2)) + String.valueOf(nf(minute(),2)) + String.valueOf(nf(second(),2)) + "_forcefieldswarp05.png");
  } 
}
